;nyquist plug-in
;version 3
;type process
;name "DBX decode..."
;action "DBX decoder..."

;; dbxDecode (Type II), V1.0 by Samuel Hunt / Maxxwave Ltd 2020
;; Needs refinement to balance the sidechain EQ (so sidechain freq response is more accurate
;;        - currently it's within about 1dB) and de-emphasis (again within about 1dB).
;; Based on the LevelSpeech.ny by Steve Daulton (www.easyspacepro.com). March 2014
;; Released under terms of the GNU General Public License version 2:
;; http://www.gnu.org/licenses/old-licenses/gpl-2.0.html

;;control amount "Leveling amount (%)" real "" 50 0 100
;;control risetime "Rise Time" real "" 0.050 0.005 100
;;control falltime "Fall Time" real "" 0.050 0.005 100


;;(setq amount (min 1 (max 0 (/ amount 100))))
;;(setq threshold (db-to-linear (* -96 amount)))
(setq ratio -1)
;;(print (linear-to-db threshold))
;;(print ratio)

(defun get-env (sig)
  (let* ((sr (snd-srate sig))
         (lookahead 0)
         ; pad the end. Really we want to remain at the
         ; last sample value but in Nyquist loads the
         ; entire sound into ram to get the value.
         (sig (if (< dur 1000)
                  (progn
                    (setq end-lev (abs-env (sref sig (- dur (/ sr)))))
                    (sim sig (snd-const end-lev dur sr 0.6)))
                  (sim sig (snd-const 1 dur sr 0.6))))
         (sidech (hp sig 65))
         (sidech (eq-highshelf sidech 2500 20 .6))
         ;(sidech (lp sidech 15000))
         ;(sidech (eq-highshelf sidech 15000 -20 0.6))
       
         ;(env (s-log (snd-exp sidech)))
         (env (s-abs sidech))
         ;(env (snd-follow env 1 0.05 0.05 0))
         ;(env (extract-abs (+ risetime (* 10 sr)) (+ risetime (* 10 sr) dur) env))
         ;(env (lp env 7))
         ;(env (lowpass2 env 7))
         (env (lp env 5.8))
         ;(env (snd-follow env 1 0.5 0.5 0))
         ;(env (sum (- 0.5)(mult ratio env)))
         ;(env (agc env 0 risetime falltime))
         ;(env (s-log env))
         ;(env (snd-exp env))
         
         
         
;         (env (sum (- 0.5)(mult ratio env)))

         ;(env (snd-exp env))
         ;(env (snd-exp env))
         ;(env (snd-exp env))
         ;(env (mult 0.25 env))
         
         ;(env (exp env 2))
         ;(end (env 0.5))
         ;(env (snd-exp (sum env (snd-log env))))
         (env (snd-exp (sum (snd-log env)(mult 0.00001 (snd-log env)))))
         (env (mult 2 env))
         
         )
         
    env))

;; absolute maximum signal
(defun max-sig (sig)
  (if (arrayp sig)
      (s-max (snd-abs (aref sig 0))(snd-abs (aref sig 1)))
      (snd-abs sig)))

;;; brick wall limiter
(defun limit (s-in)   
  (let* ((la-time (/ 300.0))                      ; lookahead time (seconds)
         (la-s (round (* la-time *sound-srate*))) ; lookahead samples
         (pad-time (* 3 la-time))                 ; padding required at start (s)
         (pad-s (* 3 la-s))                       ; padding smaples
         (padding (snd-const (peak s-in pad-s) 0 *sound-srate* (* 3.0 la-time)))
         (peak-env (snd-avg s-in (* 4 la-s) la-s OP-PEAK))
         (peak-env (sim padding (at-abs pad-time (cue peak-env))))
         (peak-env (extract 0 1 (s-max 1 peak-env))))
     (mult s-in
      (snd-exp 
        (mult -1 (snd-log peak-env))))))

(setq dur (get-duration 1))

(cond
  ((< dur 2) "Error.\nSelection must be at least 2 seconds.")
  ((= ratio 0) (mult (db-to-linear -1) (multichan-expand #'limit s)))
  (t (let ((s (multichan-expand #'limit s)))
       (eq-highshelf (mult s (get-env (max-sig s))) 750 -12 0.8)
       
       )))



